<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class UserService
    {

    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix = null;

    function __construct($db, $table_prefix)
        {
        $this->_db         =$db;
        $this->table_prefix=$table_prefix;
        }

    public function getNum()
        {
        $sql   ="select count(*) as num from " . $this->table_prefix . "users";
        $result=$this->_db->query($sql);
        $num   =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $num['num'];
        }

    public function checkAddForm($data)
        {
        $error=array();

        for ($i=0; $i < $data['num']; $i++)
            {
            if (checkBlank($data['name' . $i]))
                {
                $error['user_name' . $i]=1;
                }

            if ($data['password' . $i] != $data['password_confirm' . $i])
                {
                $error['user_password' . $i]        =1;
                $error['user_password_confirm' . $i]=1;
                }

            if (!checkAddress($data['email' . $i]))
                {
                $error['user_email' . $i]=1;
                }

            if (!checkBlank($data['homepage' . $i]) and !checkDomain($data['homepage' . $i]))
                {
                $error['user_homepage' . $i]=1;
                }

            if (!checkBlank($data['msn' . $i]) and !checkAddress($data['msn' . $i]))
                {
                $error['user_msn' . $i]=1;
                }

            if (!checkBlank($data['icq' . $i]) and !checkInt($data['icq' . $i]))
                {
                $error['user_icq' . $i]=1;
                }
            }

        return $error;
        }

    public function checkUpdateForm($data)
        {
        $error=array();

        if (checkBlank($data['name']))
            {
            $error['user_name']=1;
            }

        if ($data['password'] != $data['password_confirm'])
            {
            $error['user_password']        =1;
            $error['user_password_confirm']=1;
            }

        if (!checkAddress($data['email']))
            {
            $error['user_email']=1;
            }

        if (!checkBlank($data['homepage']) and !checkDomain($data['homepage']))
            {
            $error['user_homepage']=1;
            }

        if (!checkBlank($data['msn']) and !checkAddress($data['msn']))
            {
            $error['user_msn']=1;
            }

        if (!checkBlank($data['icq']) and !checkInt($data['icq']))
            {
            $error['user_icq']=1;
            }

        if (!checkTime($data['joindate']))
            {
            $error['user_joindate']=1;
            }

        if (!checkTime($data['lastvisit']))
            {
            $error['user_lastvisit']=1;
            }

        return $error;
        }

    public function checkAccountAddForm($data)
        {
        $error=array();

        if (!checkAddress($data['email']))
            {
            $error['account_email']=1;
            }

        if (!checkBlank($data['homepage']) and !checkDomain($data['homepage']))
            {
            $error['account_homepage']=1;
            }

        if (!checkBlank($data['msn']) and !checkAddress($data['msn']))
            {
            $error['account_msn']=1;
            }

        if (!checkBlank($data['icq']) and !checkInt($data['icq']))
            {
            $error['account_icq']=1;
            }

        if (checkBlank($data['name']))
            {
            $error['account_username']=1;
            }

        if ($data['password'] != $data['password_confirm'])
            {
            $error['account_password']       =1;
            $error['account_confirmpassword']=1;
            }

        return $error;
        }

    public function checkAccountInfoUpdateForm($data)
        {
        $error=array();

        if (!checkAddress($data['email']))
            {
            $error['account_email']=1;
            }

        if (!checkBlank($data['homepage']) and !checkDomain($data['homepage']))
            {
            $error['account_homepage']=1;
            }

        if (!checkBlank($data['msn']) and !checkAddress($data['msn']))
            {
            $error['account_msn']=1;
            }

        if (!checkBlank($data['icq']) and !checkInt($data['icq']))
            {
            $error['account_icq']=1;
            }

        return $error;
        }

    public function checkAccountPassUpdateForm($data)
        {
        $error=array();

        if ($data['new_password'] != $data['new_password_confirm'])
            {
            $error['account_newpassword']    =1;
            $error['account_confirmpassword']=1;
            }

        return $error;
        }

    public function checkLoginForm($data)
        {
        $error=array();

        return $error;
        }

    public function save($data)
        {
        for ($i=0; $i < $data['num']; $i++)
            {
            $user_role       = $data['role' . $i];
            $user_name       =$data['name' . $i];
            $user_password   =md5($data['password' . $i]);
            $user_email      =$data['email' . $i];
            $user_homepage   =$data['homepage' . $i];
            $user_msn        =$data['msn' . $i];
            $user_icq        =$data['icq' . $i];
            $user_address    =$data['address' . $i];
            $user_comments   =$data['comments' . $i];
            $user_showemail  =$data['show_email' . $i];
            $user_allowemails=$data['allow_emails' . $i];
            $user_visible    =$data['visible' . $i];
            $user_active     =$data['active' . $i];
            $user_joindate   =$user_lastvisit=time();

            if ($data['name' . $i] != "" and $data['password' . $i] == $data['password_confirm' . $i])
                {
                $sql   ="insert into " . $this->table_prefix
                    . "users(user_name,user_password,user_email,user_showemail,user_allowemails,user_visible,user_joindate,user_active,user_lastvisit,user_comments,user_homepage,user_msn,user_icq,user_address,user_role)values('"
                    . $user_name . "','" . $user_password . "','" . $user_email . "','" . $user_showemail . "','"
                    . $user_allowemails . "','" . $user_visible . "','" . $user_joindate . "','" . $user_active . "','"
                    . $user_lastvisit . "','" . $user_comments . "','" . $user_homepage . "','" . $user_msn . "','"
                    . $user_icq . "','" . $user_address . "','" . $user_role . "')";
                $result=$this->_db->query($sql);

                if ($result == false)
                    {
                    return false;
                    }
                }
            }

        return true;
        }

    public function update($data)
        {
        $user_id          =$data['id'];
        $user_name        =$data['name'];
        $user_password    =md5($data['password']);
        $user_email       =$data['email'];
        $user_showemail   =$data['show_email'];
        $user_allowemails =$data['allow_emails'];
        $user_visible     =$data['visible'];
        $data['joindate'] =timeTrans($data['joindate']);
        $user_joindate    =$data['joindate'];
        $user_active      =$data['active'];
        $data['lastvisit']=timeTrans($data['lastvisit']);
        $user_lastvisit   =$data['lastvisit'];
        $user_comments    =$data['comments'];
        $user_homepage    =$data['homepage'];
        $user_msn         =$data['msn'];
        $user_icq         =$data['icq'];
        $user_address     =$data['address'];
        $user_role        =$data['role'];

        if ($data['password'] == null and $data['password_confirm'] == null)
            {
            $sql   ="update " . $this->table_prefix . "users set " . "user_name='$user_name',"
                . "user_email='$user_email'," . "user_showemail='$user_showemail',"
                . "user_allowemails='$user_allowemails'," . "user_visible='$user_visible',"
                . "user_joindate='$user_joindate'," . "user_active='$user_active',"
                . "user_lastvisit='$user_lastvisit'," . "user_comments='$user_comments',"
                . "user_homepage='$user_homepage'," . "user_msn='$user_msn'," . "user_icq='$user_icq',"
                . "user_address='$user_address'," . "user_role='$user_role'" . "where user_id='$user_id'";
            $result=$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }
            }
        else if ($data['password'] == $data['password_confirm'])
            {
            $sql   ="update " . $this->table_prefix . "users set " . "user_name='$user_name',"
                . "user_password='$user_password'," . "user_email='$user_email'," . "user_showemail='$user_showemail',"
                . "user_allowemails='$user_allowemails'," . "user_visible='$user_visible',"
                . "user_joindate='$user_joindate'," . "user_active='$user_active',"
                . "user_lastvisit='$user_lastvisit'," . "user_comments='$user_comments',"
                . "user_homepage='$user_homepage'," . "user_msn='$user_msn'," . "user_icq='$user_icq',"
                . "user_address='$user_address'," . "user_role='$user_role'" . "where user_id='$user_id'";
            $result=$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }
            }

        return true;
        }

    public function del($ids)
        {  
        foreach ($ids as $id)
            {            
            $imageids=$this->searchImageByUserId($id);
            $GLOBALS['imageService']->del($imageids);
            $GLOBALS['lightboxService']->delUsers($id);
            $GLOBALS['commentService']->delUsers($id); 
            
            $sql   = "delete from " . $this->table_prefix . "users where user_id = '$id'";
            $result=$this->_db->query($sql);
            }
        }

    public function searchByAdmin($data)
        {
        $sql='';
        $sql.="select * from " . $this->table_prefix . "users ";
        $condition='';

        $id_condition='';

        if (trim($data['id']) != '')
            {
            $id_condition.=" user_id =" . trim($data['id']);
            }

        if ($id_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$id_condition;
                }
            else
                {
                $condition.=" and " . $id_condition;
                }
            }

        $role_condition='';

        if ($data['role'] != "all")
            {
            $role_condition.=" user_role =" . $data['role'];
            }

        if ($role_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$role_condition;
                }
            else
                {
                $condition.=" and " . $role_condition;
                }
            }

        $name_condition='';
        $terms=preg_split("/[\s]+/", $data['name'], -1, PREG_SPLIT_NO_EMPTY);
        $flag=true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $name_condition.=" user_name like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $name_condition.=" and user_name like '%" . $term . "%'";
                }
            }

        if ($name_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$name_condition;
                }
            else
                {
                $condition.=" and " . $name_condition;
                }
            }

        $email_condition='';

        if (trim($data['email']) != '')
            {
            $email_condition.=" user_email ='" . trim($data['email']) . "'";
            }

        if ($email_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$email_condition;
                }
            else
                {
                $condition.=" and " . $email_condition;
                }
            }

        $comments_condition='';
        $terms             =preg_split("/[\s]+/", $data['comments'], -1, PREG_SPLIT_NO_EMPTY);
        $flag              =true;

        foreach ($terms as $term)
            {
            if ($flag)
                {
                $comments_condition.=" user_comments like '%" . $term . "%'";
                $flag=false;
                }
            else
                {
                $comments_condition.=" and user_comments like '%" . $term . "%'";
                }
            }

        if ($comments_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$comments_condition;
                }
            else
                {
                $condition.=" and " . $comments_condition;
                }
            }

        $joinedafter_condition='';
        $data['joinedafter']=timeTrans($data['joinedafter']);

        if (trim($data['joinedafter']) != '')
            {
            $joinedafter_condition.=" user_joindate >= " . trim($data['joinedafter']);
            }

        if ($joinedafter_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$joinedafter_condition;
                }
            else
                {
                $condition.=" and " . $joinedafter_condition;
                }
            }

        $joinedbefore_condition='';
        $data['joinedbefore']=timeTrans($data['joinedbefore']);

        if (trim($data['joinedbefore']) != '')
            {
            $joinedbefore_condition.=" user_joindate <= " . trim($data['joinedbefore']);
            }

        if ($joinedbefore_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$joinedbefore_condition;
                }
            else
                {
                $condition.=" and " . $joinedbefore_condition;
                }
            }

        $lastvisitafter_condition='';
        $data['lastvisitafter']=timeTrans($data['lastvisitafter']);

        if (trim($data['lastvisitafter']) != '')
            {
            $lastvisitafter_condition.=" user_lastvisit >= " . trim($data['lastvisitafter']);
            }

        if ($lastvisitafter_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$lastvisitafter_condition;
                }
            else
                {
                $condition.=" and " . $lastvisitafter_condition;
                }
            }

        $lastvisitbefore_condition='';
        $data['lastvisitbefore']  =timeTrans($data['lastvisitbefore']);

        if (trim($data['lastvisitbefore']) != '')
            {
            $lastvisitbefore_condition.=" user_lastvisit <= " . trim($data['lastvisitbefore']);
            }

        if ($lastvisitbefore_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$lastvisitbefore_condition;
                }
            else
                {
                $condition.=" and " . $lastvisitbefore_condition;
                }
            }

        $active_condition='';

        if (trim($data['active']) == '1')
            {
            $active_condition.=" user_active='1' ";
            }
        else if (trim($data['active']) == '0')
            {
            $active_condition.=" user_active='0' ";
            }

        if ($active_condition != '')
            {
            if ($condition == '')
                {
                $condition.=$active_condition;
                }
            else
                {
                $condition.=" and " . $active_condition;
                }
            }

        if ($condition != '')
            {
            $sql.=" where " . $condition;
            }

        switch ($data['sortby'])
            {
            case "name":
                $sql.=" order by user_name " . $data['direction'];

                break;

            case "email":
                $sql.=" order by user_email " . $data['direction'];

                break;

            case "joindate":
                $sql.=" order by user_joindate " . $data['direction'];

                break;

            case "lastvisit":
                $sql.=" order by user_lastvisit " . $data['direction'];

                break;
            }

        $result=$this->_db->query($sql);
        $num=$this->_db->get_numrows($result);
        $sql.=" limit " . ($data['requestpage'] - 1) * $data['rows_per_page'] . " , " . ($data['rows_per_page']);
        $result=$this->_db->query($sql);
        $users =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $pagecount =ceil($num / ($data['rows_per_page']));
        $navigation=create_navigation($pagecount, $data['requestpage']);
        return array
            (
            "nav"   => $navigation,
            "users" => $users
            );
        }
        
    private function searchImageByUserId($id)
    {
        $ima=array();
        $sql    ="select image_id from " . $this->table_prefix . "images where user_id = '$id'";
        $result =$this->_db->query($sql);
        $imageIds=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        foreach($imageIds as $index=>$imageId)
        {
            $ima[]=$imageId['image_id'];
        }
        return $ima;
    }

    public function listUsers()
        {
        $sql    ="select user_id,user_name from " . $this->table_prefix . "users";
        $result =$this->_db->query($sql);
        $usersId=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $usersId;
        }

    public function listEmailsByRolename($role_name)
        {
        $sql   ="select user_name,user_email from " . $this->table_prefix . "users," . $this->table_prefix
            . "roles where " . $this->table_prefix . "users.user_active=1 and " . $this->table_prefix
            . "users.user_role=" . $this->table_prefix . "roles.role_id and " . $this->table_prefix
            . "roles.role_name='" . $role_name . "'";
        $result=$this->_db->query($sql);
        $emails=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $emails;
        }

    public function searchById($userId)
        {
        $sql   ="select * from " . $this->table_prefix . "users where user_id=" . $userId;
        $result=$this->_db->query($sql);
        $user  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $user;
        }

    public function searchIdsByName($name)
        {
        $sql   ="select user_id from " . $this->table_prefix . "users where user_name ='" . $name . "'";
        $result=$this->_db->query($sql);
        $id    =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $id;
        }

    public function searchEmailById($userId)
        {
        $sql   ="select user_email from " . $this->table_prefix . "users where user_id =" . $userId;
        $result=$this->_db->query($sql);
        $email =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $email['user_email'];
        }

    public function existName($name)
        {
        $sql="select * from " . $this->table_prefix . "users where user_name='" . $name . "'";
        return $this->_db->not_empty($sql);
        }

    public function genValCode()
        {
        header ("Cache-Control: no-store, no-cache, must-revalidate");
        header("Cache-Control: post-check=0, pre-check=0", false);
        header ("Content-type: image/PNG");

        srand ((double)microtime() * 1000000);
        //$im   =imagecreate(60, 20);
        $im   =imagecreatefromjpeg(ROOT_PATH . "css/background.jpg");
        $black=ImageColorAllocate($im, 0, 0, 0);
        //$gray =ImageColorAllocate($im, 200, 200, 200);

        $array="0123456789";

        for ($i=0; $i < 4; $i++)
            {
            $authnum.=substr($array, rand(0, 9), 1);
            }

        $_SESSION['auth_code']=md5($authnum);
        imagestring($im, 5, 10, 3, $authnum, $black);

        for ($i=0; $i < 200; $i++)
            {
            $randcolor = ImageColorallocate($im, rand(0, 255), rand(0, 255), rand(0, 255));
            imagesetpixel($im, rand() % 70, rand() % 30, $randcolor);
            }

        ImagePNG ($im);
        ImageDestroy ($im);
        }

    public function validate($data)
        {
        $temp=$_SESSION;

        if ($_SESSION['auth_code'] != md5($data['validate']))
            {
            return false;
            }

        $sql="select " . $this->table_prefix . "users.user_id," . $this->table_prefix . "roles.role_permissions from "
            . $this->table_prefix . "users," . $this->table_prefix . "roles where " . $this->table_prefix
            . "users.user_active=1 and " . $this->table_prefix . "users.user_role=" . $this->table_prefix
            . "roles.role_id and user_name='" . $data['user'] . "' and user_password='" . md5($data['password']) . "'";

        if ($this->_db->not_empty($sql))
            {
            $result=$this->_db->query($sql);
            $user  =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
            $this->_db->free_result($result);
            $sql   ="update " . $this->table_prefix . "users set user_lastvisit='" . time() . "' where user_id='"
                . $user['user_id'] . "'";
            $result=$this->_db->query($sql);

            if ($result == false)
                {
                return false;
                }

            $_SESSION['userId']         =$user['user_id'];
            $_SESSION['userPermissions']=$user['role_permissions'];
            return true;
            }

        return false;
        }

    public function register($data)
        {
        $user_role       ='1'; //registered user
        $user_name       =$data['name'];
        $user_password   =md5($data['password']);
        $user_email      =$data['email'];
        $user_homepage   =$data['homepage'];
        $user_msn        =$data['msn'];
        $user_icq        =$data['icq'];
        $user_address    =$data['address'];
        $user_comments   =$data['comments'];
        $user_showemail  =$data['show_email'];
        $user_allowemails=$data['allow_emails'];
        $user_visible    =$data['visible'];
        $user_active     ='1';
        $user_joindate   =$user_lastvisit=time();

        if (is_null($data['agree']))
            {
            return false;
            }

        if ($data['name'] != "" and !$this->existName($data['name']) and $data['password'] == $data['password_confirm'])
            {
            $sql   ="insert into " . $this->table_prefix
                . "users(user_name,user_password,user_email,user_showemail,user_allowemails,user_visible,user_joindate,user_active,user_lastvisit,user_comments,user_homepage,user_msn,user_icq,user_address,user_role)values('"
                . $user_name . "','" . $user_password . "','" . $user_email . "','" . $user_showemail . "','"
                . $user_allowemails . "','" . $user_visible . "','" . $user_joindate . "','" . $user_active . "','"
                . $user_lastvisit . "','" . $user_comments . "','" . $user_homepage . "','" . $user_msn . "','"
                . $user_icq . "','" . $user_address . "','" . $user_role . "')";
            $result=$this->_db->query($sql);
            return $result;
            }

        return false;
        }

    public function logout() { session_destroy(); }

    public function updateAccount($data)
        {
        $user_id         =$data['id'];
        $user_email      =$data['email'];
        $user_homepage   =$data['homepage'];
        $user_msn        =$data['msn'];
        $user_icq        =$data['icq'];
        $user_address    =$data['address'];
        $user_comments   =$data['comments'];
        $user_showemail  =$data['show_email'];
        $user_allowemails=$data['allow_emails'];
        $user_visible    =$data['visible'];
        $sql             ="update " . $this->table_prefix . "users set " . "user_email='$user_email',"
            . "user_showemail='$user_showemail'," . "user_allowemails='$user_allowemails',"
            . "user_visible='$user_visible'," . "user_comments='$user_comments'," . "user_homepage='$user_homepage',"
            . "user_msn='$user_msn'," . "user_icq='$user_icq'," . "user_address='$user_address'"
            . "where user_id='$user_id'";
        $result          =$this->_db->query($sql);
        return $result;
        }

    public function updatePassword($data)
        {
        $user_id=$data['id'];
        $sql    ="select * from " . $this->table_prefix . "users where  user_id='" . $user_id . "' and user_password='"
            . md5($data['old_password']) . "'";

        if ($this->_db->not_empty($sql) and $data['new_password'] == $data['new_password_confirm'])
            {
            $user_password=md5($data['new_password']);
            $sql          ="update " . $this->table_prefix . "users set " . "user_password='$user_password'"
                . "where user_id='$user_id'";
            $result       =$this->_db->query($sql);
            return $result;
            }

        return false;
        }

    public function matchUser($prefix)
        {
        $sql   ="select user_name from " . $this->table_prefix . "users where user_active=1 and user_name like '%"
            . $prefix . "%' order by user_name limit 0, 15";
        $result=$this->_db->query($sql);
        $users =$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        $xml='<result>';

        foreach ($users as $index => $user)
            {
            $xml.="<user>";
            $xml.=$user['user_name'];
            $xml.="</user>";
            }

        $xml.='</result>';
        return $xml;
        }
    }
?>